code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	init			; jump to install routine

new10:	cmp	ax,0004h		; setting mode 4 ?
	je	change
	cmp	ax,0005h		; setting mode 5 ?
	je	change
	jmp	cs:old10

change:	push	ax
	mov	ax,0006h		; set mode 6 (640x400x2) instead
	pushf
	call	cs:old10

	push	dx
	mov	dx,03d8h		; flip the color burst bit
	mov	al,1ah
	out	dx,al

	pop	dx
	pop	ax
	iret

old10	dd	0

init:	mov	ax,3510h		; get current INT 10 handler
	int	21h
	mov	word ptr old10,bx
	mov	word ptr old10+2,es

	mov	dx,offset new10		; install new INT 10 handler
	mov	ax,2510h
	int	21h

	mov	es,word ptr[envseg]	; free environment seg to save memory
	mov	ah,49h
	int	21h

	mov	dx,0013h		; terminate leaving DX paragraphs resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
